/* cmd_user.c - NextIRCd
 * Copyright (C) 2012-2013  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */

#include <string.h>

#include "cmd.h"
#include "struct_auth.h"
#include "struct_user.h"
#include "ircd_users.h"
#include "ircd_auth.h"

int cmd_user_cli(struct Client *client, char *argv[], int argc) {
	
	return 0;
}

int cmd_user_auth(struct Auth *auth, char *argv[], int argc) {
	char *user = argv[0];
	char *mode = argv[1];
	char *realname = argv[3];
	
	char *hostname;
	if((hostname = strchr(user, '@'))) {
		*hostname = '\0';
		if(user == hostname)
			user = "NoUser";
	}
	if(!is_ident_valid(user)) {
		// invalid user
		return 0;
	}
	
	strncpy(auth->ident, user, IDENTLEN);
	strncpy(auth->realname, realname, REALLEN);
	auth->have_user = 1;
	
	auth_try_finish(auth);
	
	return 0;
}
