/* crypt_keypacker.c - NextIRCd
 * Copyright (C) 2012-2013  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */

#include "crypt_keypacker.h"
#include "tools.h"
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

/* Pack Key
* - remove -----xy----- lines
* - remove line breaks
*/
char *crypt_rsa_packkey(char *key) {
	char *packed = malloc(strlen(key));
	
	int remove_line = 0;
	int linenum = 0;
	int i, j = 0;
	for(i = 0; key[i]; i++) {
		if(key[i] == '\r')
			continue;
		if(key[i] == '\n') {
			if(linenum == 0) {
				key[i] = 0;
				if(match("*PRIVATE KEY*", key))
					packed[j++] = '1';
				else
					packed[j++] = '0';
				key[i] = '\n';
			}
			linenum++;
			remove_line = 0;
			continue;
		}
		if(remove_line)
			continue;
		if(key[i] == '-') {
			remove_line = 1;
			continue;
		}
		packed[j++] = key[i];
	}
	return packed;
}

char *crypt_rsa_unpackkey(char *packed) {
	int size = strlen(packed);
	char *key = malloc(size + (size/64)+1 + 128);
	int kpos = 0;
	if(packed[0] == '1')
		kpos += sprintf(key + kpos, "-----BEGIN RSA PRIVATE KEY-----");
	else
		kpos += sprintf(key + kpos, "-----BEGIN PUBLIC KEY-----");
	
	int i;
	for(i = 1; i < size; i++) {
		if((i-1) % 64 == 0)
			key[kpos++] = '\n';
		key[kpos++] = packed[i];
	}
	
	if(packed[0] == '1')
		kpos += sprintf(key + kpos, "-----END RSA PRIVATE KEY-----\n");
	else
		kpos += sprintf(key + kpos, "-----END PUBLIC KEY-----\n");
	
	return key;
}
