/* ircd_config.h - NextIRCd
 * Copyright (C) 2012-2013  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */

#ifndef _ircd_config_h
#define _ircd_config_h

struct GlobalConfig;
struct ConfigPortObject;

#define CONFRELOAD_CALLBACK(NAME) void NAME()
typedef CONFRELOAD_CALLBACK(confreload_callback_t);

extern struct GlobalConfig global_config;

struct GlobalConfig {
	struct ConfigPortObject *ports;
	
};

struct ConfigPortObject {
	unsigned int port : 16;
	unsigned int secure : 1;
	unsigned int server : 1;
	unsigned int ip4only : 1;
	unsigned int ip6only : 1;
	char *bind_addr;
	
	struct ConfigPortObject *next;
};

void init_config(char *configfile);
void reload_config();

#endif
