/* struct_auth.h - NextIRCd
 * Copyright (C) 2012-2013  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */

#ifndef _struct_auth_h
#define _struct_auth_h
#include "struct_user.h"
#include <time.h>

#define PASSLEN 50

struct IODNSQuery;

struct Auth {
    struct Connection *conn;
	
    char nick[NICKLEN+1];
    char ident[IDENTLEN+1];
    char realname[REALLEN+1];
	char host[HOSTLEN+1];
    char passwd[PASSLEN+1];
	
    unsigned int ping_probe;
	time_t startup_time;
	
	struct IODNSQuery *dnslookup;
    
	unsigned int server : 1;
	unsigned int have_nick : 1;
	unsigned int have_user : 1;
	unsigned int have_pass : 1;
    
	unsigned int have_dnsresolv : 1;
	unsigned int sent_ping : 1;
	unsigned int have_pong : 1;
	
	struct Auth *prev, *next;
};

#endif
