/* struct_client.h - NextIRCd
 * Copyright (C) 2012-2013  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */

#ifndef _struct_client_h
#define _struct_client_h
#include <time.h>

#include "crypt_md5.h"
#include "struct_user.h"

struct Connection;
struct User;

struct ClientNickChange;

#define AWAYLEN  300

/* Client represents a local User */
struct Client {
    struct Connection *conn;
	struct User *user;
	
	struct ClientNickChange *nickchange;
	
	time_t userage;
	time_t nickage;
	time_t lastping;
	time_t idlelen;
    
	char *userage_sign;
	char *nickage_sign;
	
	char awaymsg[AWAYLEN-1];
	
	unsigned int isonline : 1;
	unsigned int isaway : 1;
	
	struct Client *prev, *next;
};

struct ClientNickChange {
	char newnick[NICKLEN+1];
	char nickhash[MDHASHLEN];
};

#endif
