/* struct_connection.h - NextIRCd
 * Copyright (C) 2012-2013  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */

#ifndef _struct_connection_h
#define _struct_connection_h

struct IOSocket;
struct Auth;
struct Client;
struct Server;

struct Connection {
	struct IOSocket *socket;
    struct Connection *parent;
	unsigned int listening : 1;
	unsigned int server : 1;
	unsigned int ssl : 1;
	
    unsigned int authed : 1;
    union {
        struct Auth *auth;
        struct Client *client;
        struct Server *server;
    } data;
    
	struct Connection *next, *prev; /* managed by ircd_sock.c */
};

#endif
