/* struct_servermsg.h - NextIRCd
 * Copyright (C) 2012-2013  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */

#ifndef _struct_servermsg_h
#define _struct_servermsg_h

#define MAXSERVERTOKENLEN 5

#define SERVERMSG_TYPE_UNICAST   0x01
#define SERVERMSG_TYPE_MULTICAST 0x02
#define SERVERMSG_TYPE_BROADCAST 0x03
#define SERVERMSG_TYPEMASK       0x07
#define SERVERMSG_FLAG_ENCRYPTED 0x08
#define SERVERMSG_FLAGMASK       0xF8

struct ServerMsgDestination {
	union {
		struct Server *server;
		unsigned int srvnum;
	} destination;
	unsigned int resolved_destination : 1;
};

struct ServerMsgDstMap {
	unsigned int dstcount : 8;
	struct ServerMsgDestination dst[1];
};

struct ServerMsg {
	union {
		struct Server *server;
		unsigned int srvnum;
	} source;
	unsigned int resolved_source : 1;
	
	unsigned int msgtype      : 3;
	unsigned int msgflags     : 8;
	unsigned int msglen       : 16;
	unsigned int arglen       : 16;
	unsigned int msgttl       : 8;
	
	char token[MAXSERVERTOKENLEN+1];
	
	struct ServerMsgDstMap *destinations;
	
	
	unsigned char *args;
};

#endif
