/* struct_user.h - NextIRCd
 * Copyright (C) 2012-2013  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */

#ifndef _struct_user_h
#define _struct_user_h
#include "crypt_md5.h"

#define NICKLEN   30
#define IDENTLEN  15
#define HOSTLEN   63
#define REALLEN   50

struct User {
    unsigned int usernum;
	unsigned int servernum;
	
	struct Server *server;
	
	unsigned int islocal : 1;
	
	char nick[NICKLEN+1];
	char nickhash[MDHASHLEN];
	char ident[IDENTLEN+1];
	char realname[REALLEN+1];
	char hostname[HOSTLEN+1];
	
	struct Member *channels;
};

#endif
